Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 8313)
@@ -27,8 +27,5 @@
 package org.greenstone.gatherer.cdm;
 
-/**************************************************************************************
- * Written:      ??/??/02
- * Revised:      04/07/03 - DOM support
- **************************************************************************************/
+
 import java.awt.*;
 import java.awt.event.*;
@@ -42,5 +39,6 @@
 import org.greenstone.gatherer.gui.GLIButton;
 import org.greenstone.gatherer.gui.NonWhitespaceField;
-import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.metadata.MetadataElement;
+import org.greenstone.gatherer.metadata.MetadataSetManager;
 import org.greenstone.gatherer.util.ExclusiveListSelectionListener;
 import org.greenstone.gatherer.util.StaticStrings;
@@ -245,5 +243,6 @@
 	    JLabel source_label = new JLabel();
 	    Dictionary.registerText(source_label, "CDM.SubcollectionManager.Source");
-	    Vector source_model = Gatherer.c_man.getCollection().msm.getAssignedElements();
+	    ArrayList every_metadata_set_element = MetadataSetManager.getEveryMetadataSetElement();
+	    Vector source_model = new Vector(every_metadata_set_element);
 	    source_model.add(0, StaticStrings.FILENAME_STR);
 	    source_combobox = new JComboBox(source_model);
@@ -364,5 +363,6 @@
 	public void gainFocus() {
 	    // Rebuild the sources combobox
-	    Vector source_model = Gatherer.c_man.getCollection().msm.getAssignedElements();
+	    ArrayList every_metadata_set_element = MetadataSetManager.getEveryMetadataSetElement();
+	    Vector source_model = new Vector(every_metadata_set_element);
 	    source_model.add(0, "Filename"); // Add filename as a possible source.
 	    source_combobox.setModel(new DefaultComboBoxModel(source_model));
@@ -395,10 +395,7 @@
 		String source = null;
 		Object object = source_combobox.getSelectedItem();
-		if(object instanceof ElementWrapper) {
-		    ElementWrapper element_wrapper = (ElementWrapper)object;
-		    source = element_wrapper.getName();
-		    if(source.indexOf(StaticStrings.NS_SEP) == -1) {
-			source = StaticStrings.EXTRACTED_NAMESPACE + source;
-		    }
+		if (object instanceof MetadataElement) {
+		    MetadataElement metadata_element = (MetadataElement) object;
+		    source = metadata_element.getFullName();
 		}
 		else {
@@ -481,10 +478,7 @@
 		    String source = null;
 		    Object object = source_combobox.getSelectedItem();
-		    if(object instanceof ElementWrapper) {
-			ElementWrapper element_wrapper = (ElementWrapper)object;
-			source = element_wrapper.getName();
-			if(source.indexOf(StaticStrings.NS_SEP) == -1) {
-			    source = StaticStrings.EXTRACTED_NAMESPACE + source;
-			}
+		    if (object instanceof MetadataElement) {
+			MetadataElement metadata_element = (MetadataElement) object;
+			source = metadata_element.getFullName();
 		    }
 		    else {
@@ -508,4 +502,8 @@
 	     */
 	    public void valueChanged(ListSelectionEvent event) {
+		// Wait until the event stabilises to avoid processing it multiple times
+		if (event.getValueIsAdjusting() == true) {
+		    return;
+		}
 		// Now the entry
 		if(!subcollection_list.isSelectionEmpty()) {
@@ -520,13 +518,10 @@
 		    Object value = source_combobox.getItemAt(pos);
 		    //ystem.err.println("Search for: " + s);
-		    while(value != null) {
-			if(value instanceof ElementWrapper) {
-			    ElementWrapper e = (ElementWrapper) value;
-			    String e_name = e.getName();
-			    if(e_name.indexOf(StaticStrings.NS_SEP) == -1) {
-				e_name = StaticStrings.EXTRACTED_NAMESPACE + e_name;
-			    }
+		    while (value != null) {
+			if (value instanceof MetadataElement) {
+			    MetadataElement metadata_element = (MetadataElement) value;
+			    String metadata_element_name = metadata_element.getFullName();
 			    //ystem.err.print("Compare to: " + e_name);
-			    if(e_name.equals(s)) {
+			    if (metadata_element_name.equals(s)) {
 				source_combobox.setSelectedIndex(pos);
 				value = null;
Index: /trunk/gli/src/org/greenstone/gatherer/collection/Collection.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/collection/Collection.java	(revision 8312)
+++ /trunk/gli/src/org/greenstone/gatherer/collection/Collection.java	(revision 8313)
@@ -48,6 +48,4 @@
 import org.greenstone.gatherer.cdm.CollectionMetaManager;
 import org.greenstone.gatherer.file.FileNode;
-import org.greenstone.gatherer.msm.MetadataXMLFileManager;
-import org.greenstone.gatherer.msm.MetadataSetManager;
 import org.greenstone.gatherer.util.StaticStrings;
 import org.greenstone.gatherer.util.Utility;
@@ -64,8 +62,4 @@
     /** A reference to the Collection Design Manager. */
     public CollectionDesignManager cdm;
-    /** A reference to the Greenstone Directory Metadata Manager. */
-    public MetadataXMLFileManager gdm;
-    /** A reference to the Metadata Set Manager. */
-    public MetadataSetManager msm;
     /** true if an error has occurred during construction */
     public boolean error = false;
@@ -119,6 +113,4 @@
     public void destroy() {
 	cdm.destroy();
-	gdm.destroy();
-	msm.destroy();
 	Configuration.setCollectionConfiguration(null);
 	if (Gatherer.g_man != null) {
@@ -127,6 +119,4 @@
 	cdm = null;
 	document = null;
-	gdm = null;
-	msm = null;
     }
     
@@ -170,8 +160,4 @@
     }
 
-    public MetadataXMLFileManager getGDM() {
-	return gdm;
-    }
-    
     /** Retrieve the short name for this collection.
      * @return The name as a <strong>String</strong>.
